<?php

namespace FiloBlu\Referrals\Plugin;


use FiloBlu\Referrals\Helper\Core;
use FiloBlu\Referrals\Helper\Rule;
use Magento\Framework\Registry;

class UtilityPlugin
{
    /**
     * @var Rule
     */
    protected $ruleHelper;
    /**
     * @var Core
     */
    protected $referralHelper;
    /**
     * @var Registry
     */
    private $registry;

    public function __construct(
        Core $referralHelper,
        Rule $ruleHelper,
        Registry $registry
    )
    {
        $this->ruleHelper = $ruleHelper;
        $this->referralHelper = $referralHelper;
        $this->registry = $registry;
    }

    /*
     * This is needed because ONLY the user receiving a coupon from an invite can use THAT coupon
     * That coupon is not shareable!
     */
    public function afterCanProcessRule($utility, $result, $rule, $address){

        //check if module is active
        if (!$this->referralHelper->isEnabled()){
            return $result;
        }

        //check if coupon was used yet
        $coupon = $this->referralHelper->getCuponInfo($rule->getCode());

        if (!$this->referralHelper->isInvitationalTypeCoupon($rule->getCode())) {
            return $result;
        }

        if (!$rule->getCode()) {
            return $result;
        }

        if ($coupon->getTimesUsed() > 0) {
            return false;
        }

        if($this->registry->registry('fb_referral_customer_id')){
            return $result;
        }

        //check if current cuopon is a referrall coupon
        return $this->ruleHelper->canApplyRule($rule);
    }
}
